using System;
using System.Data.SqlClient;
using SvetoforVKBot.Models.Updates;
using VkNet;
using VkNet.Enums.SafetyEnums;
using VkNet.Model.Keyboard;
using VkNet.Model.RequestParams;
using System.Text.RegularExpressions;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;

namespace SvetoforVKBot.Models.Commands.LK.Menu
{
    public class SelectDayMenuCommand : Command
    {
        public override string Name => "{\"button\":\"selectDayMenu-";

        public override void Execute(RootObject update, VkApi client, SvetoforVKBot.Data.SvetoforVKBotEntities db)
        {
        }

        public override void ExecutePL(RootObject update, VkApi client, SvetoforVKBot.Data.SvetoforVKBotEntities db)
        {
            var chatId = update.@object.message.from_id;
            MessagesSendParams @params = new MessagesSendParams();
            Regex regex = new Regex("[^0-9]");
            string msg = "";
            var keyboardBuilder = new KeyboardBuilder().Clear();
            List<Data.Svetofor> categories = new List<Data.Svetofor>();
            var row = new List<MessageKeyboardButton>();
            var listButtons = new List<ReadOnlyCollection<MessageKeyboardButton>>();
            var kbColor = KeyboardButtonColor.Positive;

            try
            {
                string[] payload = update.@object.message.payload.Split('-');
                int curDay = Convert.ToInt32(regex.Replace(payload[1], ""));

                var user = db.Users.Single(usr => usr.chatId == chatId);
                user.tag = "Меню";
                user.day = curDay;
                db.SaveChanges();             

                keyboardBuilder.AddButton("Личный кабинет", "startPL", KeyboardButtonColor.Default);

                msg = "📋Основное меню\n";

                ShowMenuDostavka showMenuDostavka = new ShowMenuDostavka();
                showMenuDostavka.Execute(update, client, db, msg, 2, 0);

            }
            catch (Exception ee)
            {
                @params.Message = "‼Ошибка в SelectDayMenuCommand: " + ee.Message;
                @params.Attachments = null;
                @params.Keyboard = null;
                @params.UserId = 59111081;
                @params.RandomId = GetRandomId();
                client.Messages.SendAsync(@params);
            }
        }
    }
}